# This file was auto-generated by Fern from our API Definition.

import typing

from ..core.client_wrapper import AsyncClientWrapper, SyncClientWrapper
from ..core.request_options import RequestOptions
from ..types.v_1_audit_response import V1AuditResponse
from .raw_client import AsyncRawAuditClient, RawAuditClient
from .types.audit_service_list_audit_events_request_filter_ops_action_type import (
    AuditServiceListAuditEventsRequestFilterOpsActionType,
)
from .types.audit_service_list_audit_events_request_filter_ops_context_access_type import (
    AuditServiceListAuditEventsRequestFilterOpsContextAccessType,
)
from .types.audit_service_list_audit_events_request_filter_ops_context_actor_type import (
    AuditServiceListAuditEventsRequestFilterOpsContextActorType,
)
from .types.audit_service_list_audit_events_request_filter_ops_context_auth_mode import (
    AuditServiceListAuditEventsRequestFilterOpsContextAuthMode,
)
from .types.audit_service_list_audit_events_request_filter_ops_resource_type import (
    AuditServiceListAuditEventsRequestFilterOpsResourceType,
)
from .types.audit_service_list_audit_events_request_sort_ops_order_by import (
    AuditServiceListAuditEventsRequestSortOpsOrderBy,
)


class AuditClient:
    def __init__(self, *, client_wrapper: SyncClientWrapper):
        self._raw_client = RawAuditClient(client_wrapper=client_wrapper)

    @property
    def with_raw_response(self) -> RawAuditClient:
        """
        Retrieves a raw implementation of this client that returns raw responses.

        Returns
        -------
        RawAuditClient
        """
        return self._raw_client

    def audit_service_list_audit_events(
        self,
        *,
        filter_ops_account_id: str,
        filter_ops_context_change_id: typing.Optional[str] = None,
        filter_ops_context_request_id: typing.Optional[str] = None,
        filter_ops_context_trace_id: typing.Optional[str] = None,
        filter_ops_context_session_id: typing.Optional[str] = None,
        filter_ops_context_actor: typing.Optional[str] = None,
        filter_ops_context_actor_type: typing.Optional[
            AuditServiceListAuditEventsRequestFilterOpsContextActorType
        ] = None,
        filter_ops_context_access_type: typing.Optional[
            AuditServiceListAuditEventsRequestFilterOpsContextAccessType
        ] = None,
        filter_ops_context_ip_address: typing.Optional[str] = None,
        filter_ops_context_origin: typing.Optional[str] = None,
        filter_ops_context_auth_mode: typing.Optional[
            AuditServiceListAuditEventsRequestFilterOpsContextAuthMode
        ] = None,
        filter_ops_context_jwt_id: typing.Optional[str] = None,
        filter_ops_context_bearer_token_context_id: typing.Optional[str] = None,
        filter_ops_parent_account_id: typing.Optional[str] = None,
        filter_ops_workspace_id: typing.Optional[str] = None,
        filter_ops_vault_id: typing.Optional[str] = None,
        filter_ops_resource_i_ds: typing.Optional[str] = None,
        filter_ops_action_type: typing.Optional[AuditServiceListAuditEventsRequestFilterOpsActionType] = None,
        filter_ops_resource_type: typing.Optional[AuditServiceListAuditEventsRequestFilterOpsResourceType] = None,
        filter_ops_tags: typing.Optional[str] = None,
        filter_ops_response_code: typing.Optional[int] = None,
        filter_ops_start_time: typing.Optional[str] = None,
        filter_ops_end_time: typing.Optional[str] = None,
        filter_ops_api_name: typing.Optional[str] = None,
        filter_ops_response_message: typing.Optional[str] = None,
        filter_ops_http_method: typing.Optional[str] = None,
        filter_ops_http_uri: typing.Optional[str] = None,
        sort_ops_sort_by: typing.Optional[str] = None,
        sort_ops_order_by: typing.Optional[AuditServiceListAuditEventsRequestSortOpsOrderBy] = None,
        after_ops_timestamp: typing.Optional[str] = None,
        after_ops_change_id: typing.Optional[str] = None,
        limit: typing.Optional[int] = None,
        offset: typing.Optional[int] = None,
        request_options: typing.Optional[RequestOptions] = None,
    ) -> V1AuditResponse:
        """
        Lists audit events that match query parameters.

        Parameters
        ----------
        filter_ops_account_id : str
            Resources with the specified account ID.

        filter_ops_context_change_id : typing.Optional[str]
            ID for the audit event.

        filter_ops_context_request_id : typing.Optional[str]
            ID for the request that caused the event.

        filter_ops_context_trace_id : typing.Optional[str]
            ID for the request set by the service that received the request.

        filter_ops_context_session_id : typing.Optional[str]
            ID for the session in which the request was sent.

        filter_ops_context_actor : typing.Optional[str]
            Member who sent the request. Depending on `actorType`, this may be a user ID or a service account ID.

        filter_ops_context_actor_type : typing.Optional[AuditServiceListAuditEventsRequestFilterOpsContextActorType]
            Type of member who sent the request.

        filter_ops_context_access_type : typing.Optional[AuditServiceListAuditEventsRequestFilterOpsContextAccessType]
            Type of access for the request.

        filter_ops_context_ip_address : typing.Optional[str]
            IP Address of the client that made the request.

        filter_ops_context_origin : typing.Optional[str]
            HTTP Origin request header (including scheme, hostname, and port) of the request.

        filter_ops_context_auth_mode : typing.Optional[AuditServiceListAuditEventsRequestFilterOpsContextAuthMode]
            Authentication mode the `actor` used.

        filter_ops_context_jwt_id : typing.Optional[str]
            ID of the JWT token.

        filter_ops_context_bearer_token_context_id : typing.Optional[str]
            Embedded User Context.

        filter_ops_parent_account_id : typing.Optional[str]
            Resources with the specified parent account ID.

        filter_ops_workspace_id : typing.Optional[str]
            Resources with the specified workspace ID.

        filter_ops_vault_id : typing.Optional[str]
            Resources with the specified vault ID.

        filter_ops_resource_i_ds : typing.Optional[str]
            Resources with a specified ID. If a resource matches at least one ID, the associated event is returned. Format is a comma-separated list of "\<resourceType\>/\<resourceID\>". For example, "VAULT/12345, USER/67890".

        filter_ops_action_type : typing.Optional[AuditServiceListAuditEventsRequestFilterOpsActionType]
            Events with the specified action type.

        filter_ops_resource_type : typing.Optional[AuditServiceListAuditEventsRequestFilterOpsResourceType]
            Resources with the specified type.

        filter_ops_tags : typing.Optional[str]
            Events with associated tags. If an event matches at least one tag, the event is returned. Comma-separated list. For example, "login, get".

        filter_ops_response_code : typing.Optional[int]
            HTTP response code of the request.

        filter_ops_start_time : typing.Optional[str]
            Start timestamp for the query, in SQL format.

        filter_ops_end_time : typing.Optional[str]
            End timestamp for the query, in SQL format.

        filter_ops_api_name : typing.Optional[str]
            Name of the API called in the request.

        filter_ops_response_message : typing.Optional[str]
            Response message of the request.

        filter_ops_http_method : typing.Optional[str]
            HTTP method of the request.

        filter_ops_http_uri : typing.Optional[str]
            HTTP URI of the request.

        sort_ops_sort_by : typing.Optional[str]
            Fully-qualified field by which to sort results. Field names should be in camel case (for example, "capitalization.camelCase").

        sort_ops_order_by : typing.Optional[AuditServiceListAuditEventsRequestSortOpsOrderBy]
            Ascending or descending ordering of results.

        after_ops_timestamp : typing.Optional[str]
            Timestamp provided in the previous audit response's `nextOps` attribute. An alternate way to manage response pagination. Can't be used with `sortOps` or `offset`. For the first request in a series of audit requests, leave blank.

        after_ops_change_id : typing.Optional[str]
            Change ID provided in the previous audit response's `nextOps` attribute. An alternate way to manage response pagination. Can't be used with `sortOps` or `offset`. For the first request in a series of audit requests, leave blank.

        limit : typing.Optional[int]
            Number of results to return.

        offset : typing.Optional[int]
            Record position at which to start returning results.

        request_options : typing.Optional[RequestOptions]
            Request-specific configuration.

        Returns
        -------
        V1AuditResponse
            A successful response.

        Examples
        --------
        from skyflow import Skyflow

        client = Skyflow(
            token="YOUR_TOKEN",
        )
        client.audit.audit_service_list_audit_events(
            filter_ops_account_id="filterOps.accountID",
        )
        """
        _response = self._raw_client.audit_service_list_audit_events(
            filter_ops_account_id=filter_ops_account_id,
            filter_ops_context_change_id=filter_ops_context_change_id,
            filter_ops_context_request_id=filter_ops_context_request_id,
            filter_ops_context_trace_id=filter_ops_context_trace_id,
            filter_ops_context_session_id=filter_ops_context_session_id,
            filter_ops_context_actor=filter_ops_context_actor,
            filter_ops_context_actor_type=filter_ops_context_actor_type,
            filter_ops_context_access_type=filter_ops_context_access_type,
            filter_ops_context_ip_address=filter_ops_context_ip_address,
            filter_ops_context_origin=filter_ops_context_origin,
            filter_ops_context_auth_mode=filter_ops_context_auth_mode,
            filter_ops_context_jwt_id=filter_ops_context_jwt_id,
            filter_ops_context_bearer_token_context_id=filter_ops_context_bearer_token_context_id,
            filter_ops_parent_account_id=filter_ops_parent_account_id,
            filter_ops_workspace_id=filter_ops_workspace_id,
            filter_ops_vault_id=filter_ops_vault_id,
            filter_ops_resource_i_ds=filter_ops_resource_i_ds,
            filter_ops_action_type=filter_ops_action_type,
            filter_ops_resource_type=filter_ops_resource_type,
            filter_ops_tags=filter_ops_tags,
            filter_ops_response_code=filter_ops_response_code,
            filter_ops_start_time=filter_ops_start_time,
            filter_ops_end_time=filter_ops_end_time,
            filter_ops_api_name=filter_ops_api_name,
            filter_ops_response_message=filter_ops_response_message,
            filter_ops_http_method=filter_ops_http_method,
            filter_ops_http_uri=filter_ops_http_uri,
            sort_ops_sort_by=sort_ops_sort_by,
            sort_ops_order_by=sort_ops_order_by,
            after_ops_timestamp=after_ops_timestamp,
            after_ops_change_id=after_ops_change_id,
            limit=limit,
            offset=offset,
            request_options=request_options,
        )
        return _response.data


class AsyncAuditClient:
    def __init__(self, *, client_wrapper: AsyncClientWrapper):
        self._raw_client = AsyncRawAuditClient(client_wrapper=client_wrapper)

    @property
    def with_raw_response(self) -> AsyncRawAuditClient:
        """
        Retrieves a raw implementation of this client that returns raw responses.

        Returns
        -------
        AsyncRawAuditClient
        """
        return self._raw_client

    async def audit_service_list_audit_events(
        self,
        *,
        filter_ops_account_id: str,
        filter_ops_context_change_id: typing.Optional[str] = None,
        filter_ops_context_request_id: typing.Optional[str] = None,
        filter_ops_context_trace_id: typing.Optional[str] = None,
        filter_ops_context_session_id: typing.Optional[str] = None,
        filter_ops_context_actor: typing.Optional[str] = None,
        filter_ops_context_actor_type: typing.Optional[
            AuditServiceListAuditEventsRequestFilterOpsContextActorType
        ] = None,
        filter_ops_context_access_type: typing.Optional[
            AuditServiceListAuditEventsRequestFilterOpsContextAccessType
        ] = None,
        filter_ops_context_ip_address: typing.Optional[str] = None,
        filter_ops_context_origin: typing.Optional[str] = None,
        filter_ops_context_auth_mode: typing.Optional[
            AuditServiceListAuditEventsRequestFilterOpsContextAuthMode
        ] = None,
        filter_ops_context_jwt_id: typing.Optional[str] = None,
        filter_ops_context_bearer_token_context_id: typing.Optional[str] = None,
        filter_ops_parent_account_id: typing.Optional[str] = None,
        filter_ops_workspace_id: typing.Optional[str] = None,
        filter_ops_vault_id: typing.Optional[str] = None,
        filter_ops_resource_i_ds: typing.Optional[str] = None,
        filter_ops_action_type: typing.Optional[AuditServiceListAuditEventsRequestFilterOpsActionType] = None,
        filter_ops_resource_type: typing.Optional[AuditServiceListAuditEventsRequestFilterOpsResourceType] = None,
        filter_ops_tags: typing.Optional[str] = None,
        filter_ops_response_code: typing.Optional[int] = None,
        filter_ops_start_time: typing.Optional[str] = None,
        filter_ops_end_time: typing.Optional[str] = None,
        filter_ops_api_name: typing.Optional[str] = None,
        filter_ops_response_message: typing.Optional[str] = None,
        filter_ops_http_method: typing.Optional[str] = None,
        filter_ops_http_uri: typing.Optional[str] = None,
        sort_ops_sort_by: typing.Optional[str] = None,
        sort_ops_order_by: typing.Optional[AuditServiceListAuditEventsRequestSortOpsOrderBy] = None,
        after_ops_timestamp: typing.Optional[str] = None,
        after_ops_change_id: typing.Optional[str] = None,
        limit: typing.Optional[int] = None,
        offset: typing.Optional[int] = None,
        request_options: typing.Optional[RequestOptions] = None,
    ) -> V1AuditResponse:
        """
        Lists audit events that match query parameters.

        Parameters
        ----------
        filter_ops_account_id : str
            Resources with the specified account ID.

        filter_ops_context_change_id : typing.Optional[str]
            ID for the audit event.

        filter_ops_context_request_id : typing.Optional[str]
            ID for the request that caused the event.

        filter_ops_context_trace_id : typing.Optional[str]
            ID for the request set by the service that received the request.

        filter_ops_context_session_id : typing.Optional[str]
            ID for the session in which the request was sent.

        filter_ops_context_actor : typing.Optional[str]
            Member who sent the request. Depending on `actorType`, this may be a user ID or a service account ID.

        filter_ops_context_actor_type : typing.Optional[AuditServiceListAuditEventsRequestFilterOpsContextActorType]
            Type of member who sent the request.

        filter_ops_context_access_type : typing.Optional[AuditServiceListAuditEventsRequestFilterOpsContextAccessType]
            Type of access for the request.

        filter_ops_context_ip_address : typing.Optional[str]
            IP Address of the client that made the request.

        filter_ops_context_origin : typing.Optional[str]
            HTTP Origin request header (including scheme, hostname, and port) of the request.

        filter_ops_context_auth_mode : typing.Optional[AuditServiceListAuditEventsRequestFilterOpsContextAuthMode]
            Authentication mode the `actor` used.

        filter_ops_context_jwt_id : typing.Optional[str]
            ID of the JWT token.

        filter_ops_context_bearer_token_context_id : typing.Optional[str]
            Embedded User Context.

        filter_ops_parent_account_id : typing.Optional[str]
            Resources with the specified parent account ID.

        filter_ops_workspace_id : typing.Optional[str]
            Resources with the specified workspace ID.

        filter_ops_vault_id : typing.Optional[str]
            Resources with the specified vault ID.

        filter_ops_resource_i_ds : typing.Optional[str]
            Resources with a specified ID. If a resource matches at least one ID, the associated event is returned. Format is a comma-separated list of "\<resourceType\>/\<resourceID\>". For example, "VAULT/12345, USER/67890".

        filter_ops_action_type : typing.Optional[AuditServiceListAuditEventsRequestFilterOpsActionType]
            Events with the specified action type.

        filter_ops_resource_type : typing.Optional[AuditServiceListAuditEventsRequestFilterOpsResourceType]
            Resources with the specified type.

        filter_ops_tags : typing.Optional[str]
            Events with associated tags. If an event matches at least one tag, the event is returned. Comma-separated list. For example, "login, get".

        filter_ops_response_code : typing.Optional[int]
            HTTP response code of the request.

        filter_ops_start_time : typing.Optional[str]
            Start timestamp for the query, in SQL format.

        filter_ops_end_time : typing.Optional[str]
            End timestamp for the query, in SQL format.

        filter_ops_api_name : typing.Optional[str]
            Name of the API called in the request.

        filter_ops_response_message : typing.Optional[str]
            Response message of the request.

        filter_ops_http_method : typing.Optional[str]
            HTTP method of the request.

        filter_ops_http_uri : typing.Optional[str]
            HTTP URI of the request.

        sort_ops_sort_by : typing.Optional[str]
            Fully-qualified field by which to sort results. Field names should be in camel case (for example, "capitalization.camelCase").

        sort_ops_order_by : typing.Optional[AuditServiceListAuditEventsRequestSortOpsOrderBy]
            Ascending or descending ordering of results.

        after_ops_timestamp : typing.Optional[str]
            Timestamp provided in the previous audit response's `nextOps` attribute. An alternate way to manage response pagination. Can't be used with `sortOps` or `offset`. For the first request in a series of audit requests, leave blank.

        after_ops_change_id : typing.Optional[str]
            Change ID provided in the previous audit response's `nextOps` attribute. An alternate way to manage response pagination. Can't be used with `sortOps` or `offset`. For the first request in a series of audit requests, leave blank.

        limit : typing.Optional[int]
            Number of results to return.

        offset : typing.Optional[int]
            Record position at which to start returning results.

        request_options : typing.Optional[RequestOptions]
            Request-specific configuration.

        Returns
        -------
        V1AuditResponse
            A successful response.

        Examples
        --------
        import asyncio

        from skyflow import AsyncSkyflow

        client = AsyncSkyflow(
            token="YOUR_TOKEN",
        )


        async def main() -> None:
            await client.audit.audit_service_list_audit_events(
                filter_ops_account_id="filterOps.accountID",
            )


        asyncio.run(main())
        """
        _response = await self._raw_client.audit_service_list_audit_events(
            filter_ops_account_id=filter_ops_account_id,
            filter_ops_context_change_id=filter_ops_context_change_id,
            filter_ops_context_request_id=filter_ops_context_request_id,
            filter_ops_context_trace_id=filter_ops_context_trace_id,
            filter_ops_context_session_id=filter_ops_context_session_id,
            filter_ops_context_actor=filter_ops_context_actor,
            filter_ops_context_actor_type=filter_ops_context_actor_type,
            filter_ops_context_access_type=filter_ops_context_access_type,
            filter_ops_context_ip_address=filter_ops_context_ip_address,
            filter_ops_context_origin=filter_ops_context_origin,
            filter_ops_context_auth_mode=filter_ops_context_auth_mode,
            filter_ops_context_jwt_id=filter_ops_context_jwt_id,
            filter_ops_context_bearer_token_context_id=filter_ops_context_bearer_token_context_id,
            filter_ops_parent_account_id=filter_ops_parent_account_id,
            filter_ops_workspace_id=filter_ops_workspace_id,
            filter_ops_vault_id=filter_ops_vault_id,
            filter_ops_resource_i_ds=filter_ops_resource_i_ds,
            filter_ops_action_type=filter_ops_action_type,
            filter_ops_resource_type=filter_ops_resource_type,
            filter_ops_tags=filter_ops_tags,
            filter_ops_response_code=filter_ops_response_code,
            filter_ops_start_time=filter_ops_start_time,
            filter_ops_end_time=filter_ops_end_time,
            filter_ops_api_name=filter_ops_api_name,
            filter_ops_response_message=filter_ops_response_message,
            filter_ops_http_method=filter_ops_http_method,
            filter_ops_http_uri=filter_ops_http_uri,
            sort_ops_sort_by=sort_ops_sort_by,
            sort_ops_order_by=sort_ops_order_by,
            after_ops_timestamp=after_ops_timestamp,
            after_ops_change_id=after_ops_change_id,
            limit=limit,
            offset=offset,
            request_options=request_options,
        )
        return _response.data
