# This file was auto-generated by Fern from our API Definition.

import typing

import pydantic
from ..core.pydantic_utilities import IS_PYDANTIC_V2, UniversalBaseModel
from .detected_entity import DetectedEntity


class DeidentifyStringResponse(UniversalBaseModel):
    """
    Response to deidentify a string.
    """

    processed_text: str = pydantic.Field()
    """
    De-identified text.
    """

    entities: typing.List[DetectedEntity] = pydantic.Field()
    """
    Detected entities.
    """

    word_count: int = pydantic.Field()
    """
    Number of words from the input text.
    """

    character_count: int = pydantic.Field()
    """
    Number of characters from the input text.
    """

    if IS_PYDANTIC_V2:
        model_config: typing.ClassVar[pydantic.ConfigDict] = pydantic.ConfigDict(extra="allow", frozen=True)  # type: ignore # Pydantic v2
    else:

        class Config:
            frozen = True
            smart_union = True
            extra = pydantic.Extra.allow
